#include <stdio.h>
#include <string.h>
#include <stdint.h>

typedef uint64_t ulong_long_int_t;
typedef int64_t slong_long_int_t;
typedef uint32_t ulong_int_t;
typedef int32_t slong_int_t;
typedef union
{
    uint16_t var;
    uint32_t __padding__;
} ushort_int_t;
typedef union
{
    int16_t var;
    uint32_t __padding__;
} sshort_int_t;
typedef union
{
    uint8_t var;
    uint32_t __padding__;
} ubyte_t;
typedef ubyte_t byte_t;
typedef union
{
    int8_t var;
    uint32_t __padding__;
} sbyte_t;
typedef size_t size_int_t;

typedef struct transition_info
{
    int* label;
    int  group;
} transition_info_t;


struct state_struct_t
{
    sshort_int_t c;
    sshort_int_t x1;
    sshort_int_t x2;
    struct
    {
        ushort_int_t state;
    }
    __attribute__((__packed__)) a1;
    struct
    {
        ushort_int_t state;
    }
    __attribute__((__packed__)) a2;
}
__attribute__((__packed__));
int state_size = sizeof(state_struct_t);

state_struct_t initial_state = { 1,0,0,0,0 };

extern "C" int get_state_size() {
    return state_size;
}

extern "C" void get_initial_state( void *to )
{
    memcpy(to, &initial_state, state_size);
}

extern "C" int have_property()
{
    return false;
}

extern "C" int get_successor( void* model, int t, state_struct_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_struct_t *out), void *arg ) 
{
    transition_info_t transition_info = { NULL, t };
    (void)model; // ignore model
    int states_emitted = 0;
    state_struct_t tmp;
    state_struct_t *out = &tmp;
    goto switch_state;
    l0: if (  ( ((*in).a1.state.var == 0) )  &&  ( ((*in).c.var < 20) ) )
    {
        *out = *in;
        (*out).a1.state.var = 1;
        ((*out).x1.var = (*out).c.var);
        // read : 1,0,0,1,0
        // write: 0,1,0,1,0
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l1: if (  ( ((*in).a1.state.var == 1) ) )
    {
        *out = *in;
        (*out).a1.state.var = 2;
        ((*out).x1.var = (*out).x1.var + (*out).c.var);
        // read : 1,1,0,1,0
        // write: 0,1,0,1,0
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l2: if (  ( ((*in).a1.state.var == 2) ) )
    {
        *out = *in;
        (*out).a1.state.var = 0;
        ((*out).c.var = (*out).x1.var);
        // read : 0,1,0,1,0
        // write: 1,0,0,1,0
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l3: if (  ( ((*in).a2.state.var == 0) )  &&  ( ((*in).c.var < 20) ) )
    {
        *out = *in;
        (*out).a2.state.var = 1;
        ((*out).x2.var = (*out).c.var);
        // read : 1,0,0,0,1
        // write: 0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l4: if (  ( ((*in).a2.state.var == 1) ) )
    {
        *out = *in;
        (*out).a2.state.var = 2;
        ((*out).x2.var = (*out).x2.var + (*out).c.var);
        // read : 1,0,1,0,1
        // write: 0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l5: if (  ( ((*in).a2.state.var == 2) ) )
    {
        *out = *in;
        (*out).a2.state.var = 0;
        ((*out).c.var = (*out).x2.var);
        // read : 0,0,1,0,1
        // write: 1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    switch_state: switch( t )
    {
        case 0: goto l0;
        case 1: goto l1;
        case 2: goto l2;
        case 3: goto l3;
        case 4: goto l4;
        case 5: goto l5;
    }
    return 0;
}

extern "C" int get_successors( void *model, state_struct_t *in, void (*callback)(void *arg, transition_info_t *transition_info, state_struct_t *out), void *arg ) 
{
    (void)model; // ignore model
    bool system_in_deadlock = true;
    transition_info_t transition_info = { NULL, -1 };
    int states_emitted = 0;
    state_struct_t tmp;
    state_struct_t *out = &tmp;
    if ( false )
    {
        ;
    }
    else
    {
        if (  ( ((*in).a1.state.var == 0) ) )
        {
            if (  ( ((*in).c.var < 20) ) )
            {
                *out = *in;
                (*out).a1.state.var = 1;
                ((*out).x1.var = (*out).c.var);
                // read : 1,0,0,1,0
                // write: 0,1,0,1,0
                system_in_deadlock = false;
                transition_info.group = 0;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).a1.state.var == 1) ) )
        {
            if ( true )
            {
                *out = *in;
                (*out).a1.state.var = 2;
                ((*out).x1.var = (*out).x1.var + (*out).c.var);
                // read : 1,1,0,1,0
                // write: 0,1,0,1,0
                system_in_deadlock = false;
                transition_info.group = 1;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).a1.state.var == 2) ) )
        {
            if ( true )
            {
                *out = *in;
                (*out).a1.state.var = 0;
                ((*out).c.var = (*out).x1.var);
                // read : 0,1,0,1,0
                // write: 1,0,0,1,0
                system_in_deadlock = false;
                transition_info.group = 2;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).a2.state.var == 0) ) )
        {
            if (  ( ((*in).c.var < 20) ) )
            {
                *out = *in;
                (*out).a2.state.var = 1;
                ((*out).x2.var = (*out).c.var);
                // read : 1,0,0,0,1
                // write: 0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 3;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).a2.state.var == 1) ) )
        {
            if ( true )
            {
                *out = *in;
                (*out).a2.state.var = 2;
                ((*out).x2.var = (*out).x2.var + (*out).c.var);
                // read : 1,0,1,0,1
                // write: 0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 4;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).a2.state.var == 2) ) )
        {
            if ( true )
            {
                *out = *in;
                (*out).a2.state.var = 0;
                ((*out).c.var = (*out).x2.var);
                // read : 0,0,1,0,1
                // write: 1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 5;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
    }
    if (  ( system_in_deadlock ) )
    {
    }
    return states_emitted;
}

extern "C" int get_state_variable_count() 
{
    return 5;
}

extern "C" const char* get_state_variable_name(int var)
{
    switch (var)
    {
        case 0:
            return "c";
        case 1:
            return "x1";
        case 2:
            return "x2";
        case 3:
            return "a1";
        case 4:
            return "a2";
        default:
            return NULL;
    }
}

extern "C" int get_state_variable_type(int var)
{
    switch (var)
    {
        case 0:
            return 0;
        case 1:
            return 0;
        case 2:
            return 0;
        case 3:
            return 1;
        case 4:
            return 2;
        default:
            return -1;
    }
}

extern "C" int get_state_variable_type_count() 
{
    return 3;
}

extern "C" const char* get_state_variable_type_name(int type) 
{
    switch (type)
    {
        case 1:
            return "a1";
        case 2:
            return "a2";
        case 0:
            return "int";
        default:
            return NULL;
    }
}

extern "C" int get_state_variable_type_value_count(int type)
{
    switch (type)
    {
        case 1: // a1
            return 3;
        case 2: // a2
            return 3;
        case 0: // int
            return 0;
        default:
            return -1;
    }
}

extern "C" const char* get_state_variable_type_value(int type, int value) 
{
    switch (type)
    {
        case 1:
        {
            switch (value)
            {
                case 0:
                    return "Q";
                case 1:
                    return "R";
                case 2:
                    return "S";
            }
        }
        case 2:
        {
            switch (value)
            {
                case 0:
                    return "Q";
                case 1:
                    return "R";
                case 2:
                    return "S";
            }
        }
    }
    return NULL;
}

int transition_dependency[][2][5] = 
{
    // { ... read ...}, { ... write ...}
    {{1,0,0,1,0},{0,1,0,1,0}},
    {{1,1,0,1,0},{0,1,0,1,0}},
    {{0,1,0,1,0},{1,0,0,1,0}},
    {{1,0,0,0,1},{0,0,1,0,1}},
    {{1,0,1,0,1},{0,0,1,0,1}},
    {{0,0,1,0,1},{1,0,0,0,1}}
}
;

extern "C" int get_transition_count() 
{
    return 6;
}

extern "C" const int* get_transition_read_dependencies(int t) 
{
    if (t>=0 && t < 6) return transition_dependency[t][0];
    return NULL;
}

extern "C" const int* get_transition_write_dependencies(int t) 
{
    if (t>=0 && t < 6) return transition_dependency[t][1];
    return NULL;
}

extern "C" int get_active( state_struct_t *in, int t ) 
{
    switch(t)
    {
        case 0: return (((*in).a1.state.var == 0));
        case 1: return (((*in).a1.state.var == 1));
        case 2: return (((*in).a1.state.var == 2));
        case 3: return (((*in).a2.state.var == 0));
        case 4: return (((*in).a2.state.var == 1));
        case 5: return (((*in).a2.state.var == 2));
    }
    return false;
}

extern "C" void get_group_pid_lid( int t, int* pid0, int* lid0, int* pid1, int* lid1 ) 
{
    switch(t)
    {
        case 0: *pid0 = 0; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 1: *pid0 = 0; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 2: *pid0 = 0; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
        case 3: *pid0 = 1; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 4: *pid0 = 1; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 5: *pid0 = 1; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
    }
    *pid0 = *lid0 = -1;
    *pid1 = *lid0 = -1;
    return;
}

extern "C" int get_guard(void* model, int g, state_struct_t* src) 
{
    (void)model;
    switch(g)
    {
        case 0: return (((*src).a1.state.var == 0));
        case 1: return (((*src).c.var < 20));
        case 2: return (((*src).a1.state.var == 1));
        case 3: return (((*src).a1.state.var == 2));
        case 4: return (((*src).a2.state.var == 0));
        case 5: return (((*src).a2.state.var == 1));
        case 6: return (((*src).a2.state.var == 2));
    }
    return false;
}

extern "C" void get_guard_all(void* model, state_struct_t* src, int* guard) 
{
    (void)model;
    guard[0] = (((*src).a1.state.var == 0));
    guard[1] = (((*src).c.var < 20));
    guard[2] = (((*src).a1.state.var == 1));
    guard[3] = (((*src).a1.state.var == 2));
    guard[4] = (((*src).a2.state.var == 0));
    guard[5] = (((*src).a2.state.var == 1));
    guard[6] = (((*src).a2.state.var == 2));
}

extern "C" const int get_guard_count() 
{
    return 7;
}

int* guards_per_transition[6] = 
{
    ((int[]){2, 0, 1}),
    ((int[]){1, 2}),
    ((int[]){1, 3}),
    ((int[]){2, 1, 4}),
    ((int[]){1, 5}),
    ((int[]){1, 6}),
}
;

extern "C" const int* get_guards(int t) 
{
    if (t>=0 && t < 6) return guards_per_transition[t];
    return NULL;
}

extern "C" const int** get_all_guards() 
{
    return (const int**)&guards_per_transition;
}

int guard[][5] = 
{
    {0,0,0,1,0},
    {1,0,0,0,0},
    {0,0,0,1,0},
    {0,0,0,1,0},
    {0,0,0,0,1},
    {0,0,0,0,1},
    {0,0,0,0,1}
}
;

extern "C" const int* get_guard_matrix(int g) 
{
    if (g>=0 && g < 7) return guard[g];
    return NULL;
}

int guardmaybecoenabled[7][7] = 
{
    {1, 1, 0, 0, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1},
    {0, 1, 1, 0, 1, 1, 1},
    {0, 1, 0, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 0, 0},
    {1, 1, 1, 1, 0, 1, 0},
    {1, 1, 1, 1, 0, 0, 1}
}
;

extern "C" const int* get_guard_may_be_coenabled_matrix(int g) 
{
    if (g>=0 && g < 7) return guardmaybecoenabled[g];
    return NULL;
}

int guard_nes[7][6] = 
{
    {0, 0, 1, 0, 0, 0},
    {1, 1, 1, 1, 1, 1},
    {1, 0, 0, 0, 0, 0},
    {0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 1},
    {0, 0, 0, 1, 0, 0},
    {0, 0, 0, 0, 1, 0}
}
;

extern "C" const int* get_guard_nes_matrix(int g) 
{
    if (g>=0 && g < 7) return guard_nes[g];
    return NULL;
}

int guard_nds[7][6] = 
{
    {1, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1},
    {0, 1, 0, 0, 0, 0},
    {0, 0, 1, 0, 0, 0},
    {0, 0, 0, 1, 0, 0},
    {0, 0, 0, 0, 1, 0},
    {0, 0, 0, 0, 0, 1}
}
;

extern "C" const int* get_guard_nds_matrix(int g) 
{
    if (g>=0 && g < 7) return guard_nds[g];
    return NULL;
}

