#include <stdio.h>
#include <string.h>
#include <stdint.h>

typedef uint64_t ulong_long_int_t;
typedef int64_t slong_long_int_t;
typedef uint32_t ulong_int_t;
typedef int32_t slong_int_t;
typedef union
{
    uint16_t var;
    uint32_t __padding__;
} ushort_int_t;
typedef union
{
    int16_t var;
    uint32_t __padding__;
} sshort_int_t;
typedef union
{
    uint8_t var;
    uint32_t __padding__;
} ubyte_t;
typedef ubyte_t byte_t;
typedef union
{
    int8_t var;
    uint32_t __padding__;
} sbyte_t;
typedef size_t size_int_t;

typedef struct transition_info
{
    int* label;
    int  group;
} transition_info_t;


struct state_struct_t
{
    byte_t Slot[2];
    byte_t next;
    struct
    {
        ushort_int_t state;
        byte_t my_place;
    }
    __attribute__((__packed__)) P_0;
    struct
    {
        ushort_int_t state;
        byte_t my_place;
    }
    __attribute__((__packed__)) P_1;
    struct
    {
        ushort_int_t state;
    }
    __attribute__((__packed__)) LTL_property;
}
__attribute__((__packed__));
int state_size = sizeof(state_struct_t);

state_struct_t initial_state = { 1,0,0,0,0,0,0,0 };

extern "C" int get_state_size() {
    return state_size;
}

extern "C" void get_initial_state( void *to )
{
    memcpy(to, &initial_state, state_size);
}

extern "C" int have_property()
{
    return true;
}

extern "C" int buchi_is_accepting( void* model, void *_state )
{
    (void)model;
    state_struct_t &state = * (state_struct_t*) _state;
    if (  ( (state.LTL_property.state.var == 1) ) )
        return true;
    return false;
}

extern "C" int get_successor( void* model, int t, state_struct_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_struct_t *out), void *arg ) 
{
    transition_info_t transition_info = { NULL, t };
    (void)model; // ignore model
    int states_emitted = 0;
    state_struct_t tmp;
    state_struct_t *out = &tmp;
    goto switch_state;
    l0: if (  ( ((*in).P_0.state.var == 0) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 1;
        ((*out).P_0.my_place.var = (*out).next.var);
        ((*out).next.var = (*out).next.var + 1);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,1,1,0,0,0,1
        // write: 0,0,1,1,1,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l1: if (  ( ((*in).P_0.state.var == 0) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 1;
        ((*out).P_0.my_place.var = (*out).next.var);
        ((*out).next.var = (*out).next.var + 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,0,0,0,1
        // write: 0,0,1,1,1,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l2: if (  ( ((*in).P_0.state.var == 0) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 1;
        ((*out).P_0.my_place.var = (*out).next.var);
        ((*out).next.var = (*out).next.var + 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,0,0,0,1
        // write: 0,0,1,1,1,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l3: if (  ( ((*in).P_0.state.var == 1) )  &&  ( ((*in).P_0.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 2;
        ((*out).next.var = (*out).next.var - 2);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,1,1,1,0,0,1
        // write: 0,0,1,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l4: if (  ( ((*in).P_0.state.var == 1) )  &&  ( ((*in).P_0.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 2;
        ((*out).next.var = (*out).next.var - 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,1,0,0,1
        // write: 0,0,1,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l5: if (  ( ((*in).P_0.state.var == 1) )  &&  ( ((*in).P_0.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 2;
        ((*out).next.var = (*out).next.var - 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,1,0,0,1
        // write: 0,0,1,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l6: if (  ( ((*in).P_0.state.var == 1) )  &&  ( ((*in).P_0.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 2;
        ((*out).P_0.my_place.var = (*out).P_0.my_place.var % 2);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,0,1,1,0,0,1
        // write: 0,0,0,1,1,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l7: if (  ( ((*in).P_0.state.var == 1) )  &&  ( ((*in).P_0.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 2;
        ((*out).P_0.my_place.var = (*out).P_0.my_place.var % 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,1,0,0,1
        // write: 0,0,0,1,1,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l8: if (  ( ((*in).P_0.state.var == 1) )  &&  ( ((*in).P_0.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 2;
        ((*out).P_0.my_place.var = (*out).P_0.my_place.var % 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,1,0,0,1
        // write: 0,0,0,1,1,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l9: if (  ( ((*in).P_0.state.var == 2) )  &&  ( ((*in).Slot[(*in).P_0.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 3;
        (*out).LTL_property.state.var = 0;
        // read : 1,1,0,1,1,0,0,1
        // write: 0,0,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l10: if (  ( ((*in).P_0.state.var == 2) )  &&  ( ((*in).Slot[(*in).P_0.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 3;
        (*out).LTL_property.state.var = 1;
        // read : 1,1,0,1,1,0,0,1
        // write: 0,0,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l11: if (  ( ((*in).P_0.state.var == 2) )  &&  ( ((*in).Slot[(*in).P_0.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 3;
        (*out).LTL_property.state.var = 1;
        // read : 1,1,0,1,1,0,0,1
        // write: 0,0,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l12: if (  ( ((*in).P_0.state.var == 3) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 4;
        ((*out).Slot[((*out).P_0.my_place.var + 2 - 1) % 2].var = 0);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,0,1,1,0,0,1
        // write: 1,1,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l13: if (  ( ((*in).P_0.state.var == 3) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 4;
        ((*out).Slot[((*out).P_0.my_place.var + 2 - 1) % 2].var = 0);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,1,0,0,1
        // write: 1,1,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l14: if (  ( ((*in).P_0.state.var == 3) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 4;
        ((*out).Slot[((*out).P_0.my_place.var + 2 - 1) % 2].var = 0);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,1,0,0,1
        // write: 1,1,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l15: if (  ( ((*in).P_0.state.var == 4) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 0;
        ((*out).Slot[((*out).P_0.my_place.var + 1) % 2].var = 1);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,0,1,1,0,0,1
        // write: 1,1,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l16: if (  ( ((*in).P_0.state.var == 4) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 0;
        ((*out).Slot[((*out).P_0.my_place.var + 1) % 2].var = 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,1,0,0,1
        // write: 1,1,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l17: if (  ( ((*in).P_0.state.var == 4) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_0.state.var = 0;
        ((*out).Slot[((*out).P_0.my_place.var + 1) % 2].var = 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,1,0,0,1
        // write: 1,1,0,1,0,0,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l18: if (  ( ((*in).P_1.state.var == 0) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 1;
        ((*out).P_1.my_place.var = (*out).next.var);
        ((*out).next.var = (*out).next.var + 1);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,1,0,0,1,0,1
        // write: 0,0,1,0,0,1,1,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l19: if (  ( ((*in).P_1.state.var == 0) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 1;
        ((*out).P_1.my_place.var = (*out).next.var);
        ((*out).next.var = (*out).next.var + 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,0,1,0,1
        // write: 0,0,1,0,0,1,1,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l20: if (  ( ((*in).P_1.state.var == 0) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 1;
        ((*out).P_1.my_place.var = (*out).next.var);
        ((*out).next.var = (*out).next.var + 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,0,1,0,1
        // write: 0,0,1,0,0,1,1,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l21: if (  ( ((*in).P_1.state.var == 1) )  &&  ( ((*in).P_1.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 2;
        ((*out).next.var = (*out).next.var - 2);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,1,0,0,1,1,1
        // write: 0,0,1,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l22: if (  ( ((*in).P_1.state.var == 1) )  &&  ( ((*in).P_1.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 2;
        ((*out).next.var = (*out).next.var - 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,0,1,1,1
        // write: 0,0,1,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l23: if (  ( ((*in).P_1.state.var == 1) )  &&  ( ((*in).P_1.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 2;
        ((*out).next.var = (*out).next.var - 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,1,1,0,1,1,1
        // write: 0,0,1,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l24: if (  ( ((*in).P_1.state.var == 1) )  &&  ( ((*in).P_1.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 2;
        ((*out).P_1.my_place.var = (*out).P_1.my_place.var % 2);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,0,0,0,1,1,1
        // write: 0,0,0,0,0,1,1,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l25: if (  ( ((*in).P_1.state.var == 1) )  &&  ( ((*in).P_1.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 2;
        ((*out).P_1.my_place.var = (*out).P_1.my_place.var % 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,0,1,1,1
        // write: 0,0,0,0,0,1,1,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l26: if (  ( ((*in).P_1.state.var == 1) )  &&  ( ((*in).P_1.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 2;
        ((*out).P_1.my_place.var = (*out).P_1.my_place.var % 2);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,0,1,1,1
        // write: 0,0,0,0,0,1,1,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l27: if (  ( ((*in).P_1.state.var == 2) )  &&  ( ((*in).Slot[(*in).P_1.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 3;
        (*out).LTL_property.state.var = 0;
        // read : 1,1,0,0,0,1,1,1
        // write: 0,0,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l28: if (  ( ((*in).P_1.state.var == 2) )  &&  ( ((*in).Slot[(*in).P_1.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 3;
        (*out).LTL_property.state.var = 1;
        // read : 1,1,0,1,0,1,1,1
        // write: 0,0,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l29: if (  ( ((*in).P_1.state.var == 2) )  &&  ( ((*in).Slot[(*in).P_1.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 3;
        (*out).LTL_property.state.var = 1;
        // read : 1,1,0,1,0,1,1,1
        // write: 0,0,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l30: if (  ( ((*in).P_1.state.var == 3) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 4;
        ((*out).Slot[((*out).P_1.my_place.var + 2 - 1) % 2].var = 0);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,0,0,0,1,1,1
        // write: 1,1,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l31: if (  ( ((*in).P_1.state.var == 3) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 4;
        ((*out).Slot[((*out).P_1.my_place.var + 2 - 1) % 2].var = 0);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,0,1,1,1
        // write: 1,1,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l32: if (  ( ((*in).P_1.state.var == 3) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 4;
        ((*out).Slot[((*out).P_1.my_place.var + 2 - 1) % 2].var = 0);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,0,1,1,1
        // write: 1,1,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l33: if (  ( ((*in).P_1.state.var == 4) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 0;
        ((*out).Slot[((*out).P_1.my_place.var + 1) % 2].var = 1);
        (*out).LTL_property.state.var = 0;
        // read : 0,0,0,0,0,1,1,1
        // write: 1,1,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l34: if (  ( ((*in).P_1.state.var == 4) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 0;
        ((*out).Slot[((*out).P_1.my_place.var + 1) % 2].var = 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,0,1,1,1
        // write: 1,1,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    l35: if (  ( ((*in).P_1.state.var == 4) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
    {
        *out = *in;
        (*out).P_1.state.var = 0;
        ((*out).Slot[((*out).P_1.my_place.var + 1) % 2].var = 1);
        (*out).LTL_property.state.var = 1;
        // read : 0,0,0,1,0,1,1,1
        // write: 1,1,0,0,0,1,0,1
        callback(arg, &transition_info, out);
        ++states_emitted;
    }
    return states_emitted;
    switch_state: switch( t )
    {
        case 0: goto l0;
        case 1: goto l1;
        case 2: goto l2;
        case 3: goto l3;
        case 4: goto l4;
        case 5: goto l5;
        case 6: goto l6;
        case 7: goto l7;
        case 8: goto l8;
        case 9: goto l9;
        case 10: goto l10;
        case 11: goto l11;
        case 12: goto l12;
        case 13: goto l13;
        case 14: goto l14;
        case 15: goto l15;
        case 16: goto l16;
        case 17: goto l17;
        case 18: goto l18;
        case 19: goto l19;
        case 20: goto l20;
        case 21: goto l21;
        case 22: goto l22;
        case 23: goto l23;
        case 24: goto l24;
        case 25: goto l25;
        case 26: goto l26;
        case 27: goto l27;
        case 28: goto l28;
        case 29: goto l29;
        case 30: goto l30;
        case 31: goto l31;
        case 32: goto l32;
        case 33: goto l33;
        case 34: goto l34;
        case 35: goto l35;
    }
    return 0;
}

extern "C" int get_successors( void *model, state_struct_t *in, void (*callback)(void *arg, transition_info_t *transition_info, state_struct_t *out), void *arg ) 
{
    (void)model; // ignore model
    bool system_in_deadlock = true;
    transition_info_t transition_info = { NULL, -1 };
    int states_emitted = 0;
    state_struct_t tmp;
    state_struct_t *out = &tmp;
    if ( false )
    {
        ;
    }
    else
    {
        if (  ( ((*in).P_0.state.var == 0) ) )
        {
            if (  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 1;
                ((*out).P_0.my_place.var = (*out).next.var);
                ((*out).next.var = (*out).next.var + 1);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,1,1,0,0,0,1
                // write: 0,0,1,1,1,0,0,1
                system_in_deadlock = false;
                transition_info.group = 0;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 1;
                ((*out).P_0.my_place.var = (*out).next.var);
                ((*out).next.var = (*out).next.var + 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,0,0,0,1
                // write: 0,0,1,1,1,0,0,1
                system_in_deadlock = false;
                transition_info.group = 1;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 1;
                ((*out).P_0.my_place.var = (*out).next.var);
                ((*out).next.var = (*out).next.var + 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,0,0,0,1
                // write: 0,0,1,1,1,0,0,1
                system_in_deadlock = false;
                transition_info.group = 2;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_0.state.var == 1) ) )
        {
            if (  ( ((*in).P_0.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 2;
                ((*out).next.var = (*out).next.var - 2);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,1,1,1,0,0,1
                // write: 0,0,1,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 3;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_0.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 2;
                ((*out).next.var = (*out).next.var - 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,1,0,0,1
                // write: 0,0,1,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 4;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_0.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 2;
                ((*out).next.var = (*out).next.var - 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,1,0,0,1
                // write: 0,0,1,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 5;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_0.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 2;
                ((*out).P_0.my_place.var = (*out).P_0.my_place.var % 2);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,0,1,1,0,0,1
                // write: 0,0,0,1,1,0,0,1
                system_in_deadlock = false;
                transition_info.group = 6;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_0.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 2;
                ((*out).P_0.my_place.var = (*out).P_0.my_place.var % 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,1,0,0,1
                // write: 0,0,0,1,1,0,0,1
                system_in_deadlock = false;
                transition_info.group = 7;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_0.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 2;
                ((*out).P_0.my_place.var = (*out).P_0.my_place.var % 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,1,0,0,1
                // write: 0,0,0,1,1,0,0,1
                system_in_deadlock = false;
                transition_info.group = 8;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_0.state.var == 2) ) )
        {
            if (  ( ((*in).Slot[(*in).P_0.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 3;
                (*out).LTL_property.state.var = 0;
                // read : 1,1,0,1,1,0,0,1
                // write: 0,0,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 9;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).Slot[(*in).P_0.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 3;
                (*out).LTL_property.state.var = 1;
                // read : 1,1,0,1,1,0,0,1
                // write: 0,0,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 10;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).Slot[(*in).P_0.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 3;
                (*out).LTL_property.state.var = 1;
                // read : 1,1,0,1,1,0,0,1
                // write: 0,0,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 11;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_0.state.var == 3) ) )
        {
            if (  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 4;
                ((*out).Slot[((*out).P_0.my_place.var + 2 - 1) % 2].var = 0);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,0,1,1,0,0,1
                // write: 1,1,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 12;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 4;
                ((*out).Slot[((*out).P_0.my_place.var + 2 - 1) % 2].var = 0);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,1,0,0,1
                // write: 1,1,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 13;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 4;
                ((*out).Slot[((*out).P_0.my_place.var + 2 - 1) % 2].var = 0);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,1,0,0,1
                // write: 1,1,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 14;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_0.state.var == 4) ) )
        {
            if (  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 0;
                ((*out).Slot[((*out).P_0.my_place.var + 1) % 2].var = 1);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,0,1,1,0,0,1
                // write: 1,1,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 15;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 0;
                ((*out).Slot[((*out).P_0.my_place.var + 1) % 2].var = 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,1,0,0,1
                // write: 1,1,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 16;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_0.state.var = 0;
                ((*out).Slot[((*out).P_0.my_place.var + 1) % 2].var = 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,1,0,0,1
                // write: 1,1,0,1,0,0,0,1
                system_in_deadlock = false;
                transition_info.group = 17;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_1.state.var == 0) ) )
        {
            if (  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 1;
                ((*out).P_1.my_place.var = (*out).next.var);
                ((*out).next.var = (*out).next.var + 1);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,1,0,0,1,0,1
                // write: 0,0,1,0,0,1,1,1
                system_in_deadlock = false;
                transition_info.group = 18;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 1;
                ((*out).P_1.my_place.var = (*out).next.var);
                ((*out).next.var = (*out).next.var + 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,0,1,0,1
                // write: 0,0,1,0,0,1,1,1
                system_in_deadlock = false;
                transition_info.group = 19;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 1;
                ((*out).P_1.my_place.var = (*out).next.var);
                ((*out).next.var = (*out).next.var + 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,0,1,0,1
                // write: 0,0,1,0,0,1,1,1
                system_in_deadlock = false;
                transition_info.group = 20;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_1.state.var == 1) ) )
        {
            if (  ( ((*in).P_1.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 2;
                ((*out).next.var = (*out).next.var - 2);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,1,0,0,1,1,1
                // write: 0,0,1,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 21;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_1.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 2;
                ((*out).next.var = (*out).next.var - 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,0,1,1,1
                // write: 0,0,1,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 22;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_1.my_place.var == 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 2;
                ((*out).next.var = (*out).next.var - 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,1,1,0,1,1,1
                // write: 0,0,1,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 23;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_1.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 2;
                ((*out).P_1.my_place.var = (*out).P_1.my_place.var % 2);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,0,0,0,1,1,1
                // write: 0,0,0,0,0,1,1,1
                system_in_deadlock = false;
                transition_info.group = 24;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_1.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 2;
                ((*out).P_1.my_place.var = (*out).P_1.my_place.var % 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,0,1,1,1
                // write: 0,0,0,0,0,1,1,1
                system_in_deadlock = false;
                transition_info.group = 25;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).P_1.my_place.var != 2 - 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 2;
                ((*out).P_1.my_place.var = (*out).P_1.my_place.var % 2);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,0,1,1,1
                // write: 0,0,0,0,0,1,1,1
                system_in_deadlock = false;
                transition_info.group = 26;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_1.state.var == 2) ) )
        {
            if (  ( ((*in).Slot[(*in).P_1.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 3;
                (*out).LTL_property.state.var = 0;
                // read : 1,1,0,0,0,1,1,1
                // write: 0,0,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 27;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).Slot[(*in).P_1.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 3;
                (*out).LTL_property.state.var = 1;
                // read : 1,1,0,1,0,1,1,1
                // write: 0,0,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 28;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).Slot[(*in).P_1.my_place.var].var == 1) )  &&  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 3;
                (*out).LTL_property.state.var = 1;
                // read : 1,1,0,1,0,1,1,1
                // write: 0,0,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 29;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_1.state.var == 3) ) )
        {
            if (  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 4;
                ((*out).Slot[((*out).P_1.my_place.var + 2 - 1) % 2].var = 0);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,0,0,0,1,1,1
                // write: 1,1,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 30;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 4;
                ((*out).Slot[((*out).P_1.my_place.var + 2 - 1) % 2].var = 0);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,0,1,1,1
                // write: 1,1,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 31;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 4;
                ((*out).Slot[((*out).P_1.my_place.var + 2 - 1) % 2].var = 0);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,0,1,1,1
                // write: 1,1,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 32;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
        if (  ( ((*in).P_1.state.var == 4) ) )
        {
            if (  ( ((*in).LTL_property.state.var == 0) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 0;
                ((*out).Slot[((*out).P_1.my_place.var + 1) % 2].var = 1);
                (*out).LTL_property.state.var = 0;
                // read : 0,0,0,0,0,1,1,1
                // write: 1,1,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 33;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 0;
                ((*out).Slot[((*out).P_1.my_place.var + 1) % 2].var = 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,0,1,1,1
                // write: 1,1,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 34;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
            if (  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
            {
                *out = *in;
                (*out).P_1.state.var = 0;
                ((*out).Slot[((*out).P_1.my_place.var + 1) % 2].var = 1);
                (*out).LTL_property.state.var = 1;
                // read : 0,0,0,1,0,1,1,1
                // write: 1,1,0,0,0,1,0,1
                system_in_deadlock = false;
                transition_info.group = 35;
                callback(arg, &transition_info, out);
                ++states_emitted;
            }
        }
    }
    if (  ( system_in_deadlock ) )
    {
        if (  ( ((*in).LTL_property.state.var == 0) ) )
        {
            *out = *in;
            (*out).LTL_property.state.var = 0;
            transition_info.group = 36;
            callback(arg, &transition_info, out);
            ++states_emitted;
        }
        if (  ( ((*in).LTL_property.state.var == 0) )  &&  ( ((((*in).P_0.state.var == 1) || ((*in).P_0.state.var == 2) || ((*in).P_0.state.var == 3)) &&  ! ((((*in).P_0.state.var == 4)) )) ) )
        {
            *out = *in;
            (*out).LTL_property.state.var = 1;
            transition_info.group = 37;
            callback(arg, &transition_info, out);
            ++states_emitted;
        }
        if (  ( ((*in).LTL_property.state.var == 1) )  &&  ( ( ! ((((*in).P_0.state.var == 4)) )) ) )
        {
            *out = *in;
            (*out).LTL_property.state.var = 1;
            transition_info.group = 38;
            callback(arg, &transition_info, out);
            ++states_emitted;
        }
    }
    return states_emitted;
}

extern "C" int get_state_variable_count() 
{
    return 8;
}

extern "C" const char* get_state_variable_name(int var)
{
    switch (var)
    {
        case 0:
            return "Slot[0]";
        case 1:
            return "Slot[1]";
        case 2:
            return "next";
        case 3:
            return "P_0";
        case 4:
            return "P_0.my_place";
        case 5:
            return "P_1";
        case 6:
            return "P_1.my_place";
        case 7:
            return "LTL_property";
        default:
            return NULL;
    }
}

extern "C" int get_state_variable_type(int var)
{
    switch (var)
    {
        case 0:
            return 0;
        case 1:
            return 0;
        case 2:
            return 0;
        case 3:
            return 1;
        case 4:
            return 0;
        case 5:
            return 2;
        case 6:
            return 0;
        case 7:
            return 3;
        default:
            return -1;
    }
}

extern "C" int get_state_variable_type_count() 
{
    return 4;
}

extern "C" const char* get_state_variable_type_name(int type) 
{
    switch (type)
    {
        case 3:
            return "LTL_property";
        case 1:
            return "P_0";
        case 2:
            return "P_1";
        case 0:
            return "byte";
        default:
            return NULL;
    }
}

extern "C" int get_state_variable_type_value_count(int type)
{
    switch (type)
    {
        case 3: // LTL_property
            return 2;
        case 1: // P_0
            return 5;
        case 2: // P_1
            return 5;
        case 0: // byte
            return 0;
        default:
            return -1;
    }
}

extern "C" const char* get_state_variable_type_value(int type, int value) 
{
    switch (type)
    {
        case 3:
        {
            switch (value)
            {
                case 0:
                    return "q1";
                case 1:
                    return "q2";
            }
        }
        case 1:
        {
            switch (value)
            {
                case 0:
                    return "NCS";
                case 1:
                    return "p1";
                case 2:
                    return "p2";
                case 3:
                    return "p3";
                case 4:
                    return "CS";
            }
        }
        case 2:
        {
            switch (value)
            {
                case 0:
                    return "NCS";
                case 1:
                    return "p1";
                case 2:
                    return "p2";
                case 3:
                    return "p3";
                case 4:
                    return "CS";
            }
        }
    }
    return NULL;
}

int transition_dependency[][2][8] = 
{
    // { ... read ...}, { ... write ...}
    {{0,0,1,1,0,0,0,1},{0,0,1,1,1,0,0,1}},
    {{0,0,1,1,0,0,0,1},{0,0,1,1,1,0,0,1}},
    {{0,0,1,1,0,0,0,1},{0,0,1,1,1,0,0,1}},
    {{0,0,1,1,1,0,0,1},{0,0,1,1,0,0,0,1}},
    {{0,0,1,1,1,0,0,1},{0,0,1,1,0,0,0,1}},
    {{0,0,1,1,1,0,0,1},{0,0,1,1,0,0,0,1}},
    {{0,0,0,1,1,0,0,1},{0,0,0,1,1,0,0,1}},
    {{0,0,0,1,1,0,0,1},{0,0,0,1,1,0,0,1}},
    {{0,0,0,1,1,0,0,1},{0,0,0,1,1,0,0,1}},
    {{1,1,0,1,1,0,0,1},{0,0,0,1,0,0,0,1}},
    {{1,1,0,1,1,0,0,1},{0,0,0,1,0,0,0,1}},
    {{1,1,0,1,1,0,0,1},{0,0,0,1,0,0,0,1}},
    {{0,0,0,1,1,0,0,1},{1,1,0,1,0,0,0,1}},
    {{0,0,0,1,1,0,0,1},{1,1,0,1,0,0,0,1}},
    {{0,0,0,1,1,0,0,1},{1,1,0,1,0,0,0,1}},
    {{0,0,0,1,1,0,0,1},{1,1,0,1,0,0,0,1}},
    {{0,0,0,1,1,0,0,1},{1,1,0,1,0,0,0,1}},
    {{0,0,0,1,1,0,0,1},{1,1,0,1,0,0,0,1}},
    {{0,0,1,0,0,1,0,1},{0,0,1,0,0,1,1,1}},
    {{0,0,1,1,0,1,0,1},{0,0,1,0,0,1,1,1}},
    {{0,0,1,1,0,1,0,1},{0,0,1,0,0,1,1,1}},
    {{0,0,1,0,0,1,1,1},{0,0,1,0,0,1,0,1}},
    {{0,0,1,1,0,1,1,1},{0,0,1,0,0,1,0,1}},
    {{0,0,1,1,0,1,1,1},{0,0,1,0,0,1,0,1}},
    {{0,0,0,0,0,1,1,1},{0,0,0,0,0,1,1,1}},
    {{0,0,0,1,0,1,1,1},{0,0,0,0,0,1,1,1}},
    {{0,0,0,1,0,1,1,1},{0,0,0,0,0,1,1,1}},
    {{1,1,0,0,0,1,1,1},{0,0,0,0,0,1,0,1}},
    {{1,1,0,1,0,1,1,1},{0,0,0,0,0,1,0,1}},
    {{1,1,0,1,0,1,1,1},{0,0,0,0,0,1,0,1}},
    {{0,0,0,0,0,1,1,1},{1,1,0,0,0,1,0,1}},
    {{0,0,0,1,0,1,1,1},{1,1,0,0,0,1,0,1}},
    {{0,0,0,1,0,1,1,1},{1,1,0,0,0,1,0,1}},
    {{0,0,0,0,0,1,1,1},{1,1,0,0,0,1,0,1}},
    {{0,0,0,1,0,1,1,1},{1,1,0,0,0,1,0,1}},
    {{0,0,0,1,0,1,1,1},{1,1,0,0,0,1,0,1}}
}
;

extern "C" int get_transition_count() 
{
    return 36;
}

extern "C" const int* get_transition_read_dependencies(int t) 
{
    if (t>=0 && t < 36) return transition_dependency[t][0];
    return NULL;
}

extern "C" const int* get_transition_write_dependencies(int t) 
{
    if (t>=0 && t < 36) return transition_dependency[t][1];
    return NULL;
}

extern "C" int get_active( state_struct_t *in, int t ) 
{
    switch(t)
    {
        case 0: return (((*in).P_0.state.var == 0));
        case 1: return (((*in).P_0.state.var == 0));
        case 2: return (((*in).P_0.state.var == 0));
        case 3: return (((*in).P_0.state.var == 1));
        case 4: return (((*in).P_0.state.var == 1));
        case 5: return (((*in).P_0.state.var == 1));
        case 6: return (((*in).P_0.state.var == 1));
        case 7: return (((*in).P_0.state.var == 1));
        case 8: return (((*in).P_0.state.var == 1));
        case 9: return (((*in).P_0.state.var == 2));
        case 10: return (((*in).P_0.state.var == 2));
        case 11: return (((*in).P_0.state.var == 2));
        case 12: return (((*in).P_0.state.var == 3));
        case 13: return (((*in).P_0.state.var == 3));
        case 14: return (((*in).P_0.state.var == 3));
        case 15: return (((*in).P_0.state.var == 4));
        case 16: return (((*in).P_0.state.var == 4));
        case 17: return (((*in).P_0.state.var == 4));
        case 18: return (((*in).P_1.state.var == 0));
        case 19: return (((*in).P_1.state.var == 0));
        case 20: return (((*in).P_1.state.var == 0));
        case 21: return (((*in).P_1.state.var == 1));
        case 22: return (((*in).P_1.state.var == 1));
        case 23: return (((*in).P_1.state.var == 1));
        case 24: return (((*in).P_1.state.var == 1));
        case 25: return (((*in).P_1.state.var == 1));
        case 26: return (((*in).P_1.state.var == 1));
        case 27: return (((*in).P_1.state.var == 2));
        case 28: return (((*in).P_1.state.var == 2));
        case 29: return (((*in).P_1.state.var == 2));
        case 30: return (((*in).P_1.state.var == 3));
        case 31: return (((*in).P_1.state.var == 3));
        case 32: return (((*in).P_1.state.var == 3));
        case 33: return (((*in).P_1.state.var == 4));
        case 34: return (((*in).P_1.state.var == 4));
        case 35: return (((*in).P_1.state.var == 4));
    }
    return false;
}

extern "C" void get_group_pid_lid( int t, int* pid0, int* lid0, int* pid1, int* lid1 ) 
{
    switch(t)
    {
        case 0: *pid0 = 0; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 1: *pid0 = 0; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 2: *pid0 = 0; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 3: *pid0 = 0; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 4: *pid0 = 0; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 5: *pid0 = 0; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 6: *pid0 = 0; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 7: *pid0 = 0; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 8: *pid0 = 0; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 9: *pid0 = 0; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
        case 10: *pid0 = 0; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
        case 11: *pid0 = 0; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
        case 12: *pid0 = 0; *lid0 = 3; *pid1 = -1; *lid1 = -1; return;
        case 13: *pid0 = 0; *lid0 = 3; *pid1 = -1; *lid1 = -1; return;
        case 14: *pid0 = 0; *lid0 = 3; *pid1 = -1; *lid1 = -1; return;
        case 15: *pid0 = 0; *lid0 = 4; *pid1 = -1; *lid1 = -1; return;
        case 16: *pid0 = 0; *lid0 = 4; *pid1 = -1; *lid1 = -1; return;
        case 17: *pid0 = 0; *lid0 = 4; *pid1 = -1; *lid1 = -1; return;
        case 18: *pid0 = 1; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 19: *pid0 = 1; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 20: *pid0 = 1; *lid0 = 0; *pid1 = -1; *lid1 = -1; return;
        case 21: *pid0 = 1; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 22: *pid0 = 1; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 23: *pid0 = 1; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 24: *pid0 = 1; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 25: *pid0 = 1; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 26: *pid0 = 1; *lid0 = 1; *pid1 = -1; *lid1 = -1; return;
        case 27: *pid0 = 1; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
        case 28: *pid0 = 1; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
        case 29: *pid0 = 1; *lid0 = 2; *pid1 = -1; *lid1 = -1; return;
        case 30: *pid0 = 1; *lid0 = 3; *pid1 = -1; *lid1 = -1; return;
        case 31: *pid0 = 1; *lid0 = 3; *pid1 = -1; *lid1 = -1; return;
        case 32: *pid0 = 1; *lid0 = 3; *pid1 = -1; *lid1 = -1; return;
        case 33: *pid0 = 1; *lid0 = 4; *pid1 = -1; *lid1 = -1; return;
        case 34: *pid0 = 1; *lid0 = 4; *pid1 = -1; *lid1 = -1; return;
        case 35: *pid0 = 1; *lid0 = 4; *pid1 = -1; *lid1 = -1; return;
    }
    *pid0 = *lid0 = -1;
    *pid1 = *lid0 = -1;
    return;
}

extern "C" int get_guard(void* model, int g, state_struct_t* src) 
{
    (void)model;
    switch(g)
    {
        case 0: return (((*src).P_0.state.var == 0));
        case 1: return (((*src).P_0.state.var == 1));
        case 2: return (((*src).P_0.my_place.var == 2 - 1));
        case 3: return (((*src).P_0.my_place.var != 2 - 1));
        case 4: return (((*src).P_0.state.var == 2));
        case 5: return (((*src).Slot[(*src).P_0.my_place.var].var == 1));
        case 6: return (((*src).P_0.state.var == 3));
        case 7: return (((*src).P_0.state.var == 4));
        case 8: return (((*src).P_1.state.var == 0));
        case 9: return (((*src).P_1.state.var == 1));
        case 10: return (((*src).P_1.my_place.var == 2 - 1));
        case 11: return (((*src).P_1.my_place.var != 2 - 1));
        case 12: return (((*src).P_1.state.var == 2));
        case 13: return (((*src).Slot[(*src).P_1.my_place.var].var == 1));
        case 14: return (((*src).P_1.state.var == 3));
        case 15: return (((*src).P_1.state.var == 4));
    }
    return false;
}

extern "C" void get_guard_all(void* model, state_struct_t* src, int* guard) 
{
    (void)model;
    guard[0] = (((*src).P_0.state.var == 0));
    guard[1] = (((*src).P_0.state.var == 1));
    guard[2] = (((*src).P_0.my_place.var == 2 - 1));
    guard[3] = (((*src).P_0.my_place.var != 2 - 1));
    guard[4] = (((*src).P_0.state.var == 2));
    guard[5] = (((*src).Slot[(*src).P_0.my_place.var].var == 1));
    guard[6] = (((*src).P_0.state.var == 3));
    guard[7] = (((*src).P_0.state.var == 4));
    guard[8] = (((*src).P_1.state.var == 0));
    guard[9] = (((*src).P_1.state.var == 1));
    guard[10] = (((*src).P_1.my_place.var == 2 - 1));
    guard[11] = (((*src).P_1.my_place.var != 2 - 1));
    guard[12] = (((*src).P_1.state.var == 2));
    guard[13] = (((*src).Slot[(*src).P_1.my_place.var].var == 1));
    guard[14] = (((*src).P_1.state.var == 3));
    guard[15] = (((*src).P_1.state.var == 4));
}

extern "C" const int get_guard_count() 
{
    return 16;
}

int* guards_per_transition[36] = 
{
    ((int[]){1, 0}),
    ((int[]){1, 0}),
    ((int[]){1, 0}),
    ((int[]){2, 1, 2}),
    ((int[]){2, 1, 2}),
    ((int[]){2, 1, 2}),
    ((int[]){2, 1, 3}),
    ((int[]){2, 1, 3}),
    ((int[]){2, 1, 3}),
    ((int[]){2, 4, 5}),
    ((int[]){2, 4, 5}),
    ((int[]){2, 4, 5}),
    ((int[]){1, 6}),
    ((int[]){1, 6}),
    ((int[]){1, 6}),
    ((int[]){1, 7}),
    ((int[]){1, 7}),
    ((int[]){1, 7}),
    ((int[]){1, 8}),
    ((int[]){1, 8}),
    ((int[]){1, 8}),
    ((int[]){2, 9, 10}),
    ((int[]){2, 9, 10}),
    ((int[]){2, 9, 10}),
    ((int[]){2, 9, 11}),
    ((int[]){2, 9, 11}),
    ((int[]){2, 9, 11}),
    ((int[]){2, 12, 13}),
    ((int[]){2, 12, 13}),
    ((int[]){2, 12, 13}),
    ((int[]){1, 14}),
    ((int[]){1, 14}),
    ((int[]){1, 14}),
    ((int[]){1, 15}),
    ((int[]){1, 15}),
    ((int[]){1, 15}),
}
;

extern "C" const int* get_guards(int t) 
{
    if (t>=0 && t < 36) return guards_per_transition[t];
    return NULL;
}

extern "C" const int** get_all_guards() 
{
    return (const int**)&guards_per_transition;
}

int guard[][8] = 
{
    {0,0,0,1,0,0,0,0},
    {0,0,0,1,0,0,0,0},
    {0,0,0,0,1,0,0,0},
    {0,0,0,0,1,0,0,0},
    {0,0,0,1,0,0,0,0},
    {1,1,0,0,1,0,0,0},
    {0,0,0,1,0,0,0,0},
    {0,0,0,1,0,0,0,0},
    {0,0,0,0,0,1,0,0},
    {0,0,0,0,0,1,0,0},
    {0,0,0,0,0,0,1,0},
    {0,0,0,0,0,0,1,0},
    {0,0,0,0,0,1,0,0},
    {1,1,0,0,0,0,1,0},
    {0,0,0,0,0,1,0,0},
    {0,0,0,0,0,1,0,0}
}
;

extern "C" const int* get_guard_matrix(int g) 
{
    if (g>=0 && g < 16) return guard[g];
    return NULL;
}

int guardmaybecoenabled[16][16] = 
{
    {1, 0, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 1}
}
;

extern "C" const int* get_guard_may_be_coenabled_matrix(int g) 
{
    if (g>=0 && g < 16) return guardmaybecoenabled[g];
    return NULL;
}

int guard_nes[16][36] = 
{
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0}
}
;

extern "C" const int* get_guard_nes_matrix(int g) 
{
    if (g>=0 && g < 16) return guard_nes[g];
    return NULL;
}

int guard_nds[16][36] = 
{
    {1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1}
}
;

extern "C" const int* get_guard_nds_matrix(int g) 
{
    if (g>=0 && g < 16) return guard_nds[g];
    return NULL;
}

