/** Generated LTSmin model - chan_op.prom
 * State size:  10 elements (40 bytes)
 * Transitions: 20
 */

#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <assert.h>

typedef struct transition_info
{
	int* label;
	int  group;
} transition_info_t;
typedef union sj_int1 {
	int pad;
	unsigned int var:1;
} sj_int1;
typedef union sj_int8 {
	int pad;
	char var;
} sj_int8;
typedef union sj_int16 {
	int pad;
	short var;
} sj_int16;
typedef union sj_int32 {
	int pad;
	int var;
} sj_int32;
typedef union sj_uint8 {
	int pad;
	unsigned char var;
} sj_uint8;
typedef union sj_uint16 {
	int pad;
	unsigned short var;
} sj_uint16;
typedef union sj_uint32 {
	int pad;
	unsigned int var;
} sj_uint32;
typedef struct sj_channel {
	unsigned int isRendezVous: 2;
	unsigned int nextRead: 15;
	unsigned int filled: 15;
} sj_channel;
typedef 
struct ch_c_t {
	sj_int32 m0;
}
ch_c_t;

typedef 
struct state_globals_t {
	sj_int32 prioritiseProcess;
	sj_uint8 _nr_pr;
}
state_globals_t;

typedef 
struct state_init_t {
	sj_int32 pc;
	sj_channel c;
	ch_c_t c_buffer[5];
	sj_int32 i;
}
state_init_t;

typedef 
struct state_t {
	state_globals_t globals;
	state_init_t init;
}
state_t;

extern int spinja_get_successor_all( void* model, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg );
extern int spinja_get_successor( void* model, int t, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg );
int spinja_is_atomic(void* model, state_t* tmp) {
	return tmp->globals.prioritiseProcess.var >= 0;
}
int state_size = 10;
extern int spinja_get_state_size() {
	return 10;
}
state_t initial = (state_t){0,0,0,0,0,0,0,0,0,0,0,0};

extern void spinja_get_initial_state( state_t *to )
{
	if(state_size*4 != sizeof(state_t)) { printf("state_t SIZE MISMATCH!: state=%i(%i) globals=%i",sizeof(state_t),state_size*4,sizeof(state_globals_t)); }
	memcpy(to, (char*)&initial, sizeof(state_t));
	to->globals.prioritiseProcess.var = -1;
}
int spinja_get_successor( void* model, int t, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg) {
	transition_info_t transition_info = { NULL, t };
	(void)model; // ignore model
	register int pos;
	state_t local_state;
	state_t* tmp = &local_state;

	static int n_losses = 0;
	static int n_atomics = 0;

	#ifdef COUNTATOMIC
		if(t==1 && spinja_is_atomic(model,in)) printf("handled atomic statements so far: %i\n",++n_atomics);
	#endif
	switch(t) {
	case 0: { // init
		if( true 
		 && (in->init.pc.var == 0)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 1;
			printf("%d", (in->init.c.filled== 0));
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 1: { // init
		if( true 
		 && (in->init.pc.var == 1)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled < 5) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 2;
			pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
			tmp->init.c_buffer[pos].m0.var = 5;
			++(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 2: { // init
		if( true 
		 && (in->init.pc.var == 2)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled < 5) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 3;
			pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
			tmp->init.c_buffer[pos].m0.var = 4;
			++(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 3: { // init
		if( true 
		 && (in->init.pc.var == 3)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled < 5) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 4;
			pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
			tmp->init.c_buffer[pos].m0.var = 3;
			++(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 4: { // init
		if( true 
		 && (in->init.pc.var == 4)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled < 5) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 5;
			pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
			tmp->init.c_buffer[pos].m0.var = 2;
			++(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 5: { // init
		if( true 
		 && (in->init.pc.var == 5)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled < 5) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 6;
			pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
			tmp->init.c_buffer[pos].m0.var = 1;
			++(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 6: { // init
		if( true 
		 && (in->init.pc.var == 6)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled > 0) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 7;
			pos = tmp->init.c.nextRead;
			tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
			tmp->init.c_buffer[pos].m0.pad = 0;
			tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
			--(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 7: { // init
		if( true 
		 && (in->init.pc.var == 7)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 8;
			printf("%d", (in->init.c.filled!=5));
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 8: { // init
		if( true 
		 && (in->init.pc.var == 8)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled < 5) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 9;
			pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
			tmp->init.c_buffer[pos].m0.var = 9;
			++(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 9: { // init
		if( true 
		 && (in->init.pc.var == 9)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 10;
			printf("%d", (in->init.c.filled==5));
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 10: { // init
		if( true 
		 && (in->init.pc.var == 10)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled > 0) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 11;
			pos = tmp->init.c.nextRead;
			tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
			tmp->init.c_buffer[pos].m0.pad = 0;
			tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
			--(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 11: { // init
		if( true 
		 && (in->init.pc.var == 11)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled > 0) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 12;
			pos = tmp->init.c.nextRead;
			tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
			tmp->init.c_buffer[pos].m0.pad = 0;
			tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
			--(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 12: { // init
		if( true 
		 && (in->init.pc.var == 12)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled > 0) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 13;
			pos = tmp->init.c.nextRead;
			tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
			tmp->init.c_buffer[pos].m0.pad = 0;
			tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
			--(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 13: { // init
		if( true 
		 && (in->init.pc.var == 13)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled > 0) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 14;
			pos = tmp->init.c.nextRead;
			tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
			tmp->init.c_buffer[pos].m0.pad = 0;
			tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
			--(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 14: { // init
		if( true 
		 && (in->init.pc.var == 14)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 15;
			printf("%d", (in->init.c.filled!= 0));
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 15: { // init
		if( true 
		 && (in->init.pc.var == 15)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 16;
			printf("%d", in->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 16: { // init
		if( true 
		 && (in->init.pc.var == 16)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled > 0) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 17;
			pos = tmp->init.c.nextRead;
			tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
			tmp->init.c_buffer[pos].m0.pad = 0;
			tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
			--(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 17: { // init
		if( true 
		 && (in->init.pc.var == 17)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 18;
			printf("%d", (in->init.i.var == 9 ? 1 : 0));
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 18: { // init
		if( true 
		 && (in->init.pc.var == 18)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && true ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = -1;
			#ifndef NORESETPROCESS
			memset(&tmp->init,-1,sizeof(state_init_t));
			#endif
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 19: { // loss of atomicity
		break;
	}
	}
	return 0;
}

int spinja_get_successor_all( void* model, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg) {
	transition_info_t transition_info = { NULL, -1 };
	(void)model; // ignore model
	int states_emitted = 0;
	register int pos;
	state_t local_state;
	state_t* tmp = &local_state;

	static int n_losses = 0;
	static int n_atomics = 0;

	#ifdef COUNTATOMIC
		if(spinja_is_atomic(model,in))printf("handled atomic statements so far: %i\n",++n_atomics);
	#endif
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 0)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 1;
				printf("%d", (in->init.c.filled== 0));
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 0;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 1)) {
			if (true
			&&(in->init.c.filled < 5)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 2;
				pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
				tmp->init.c_buffer[pos].m0.var = 5;
				++(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 1;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 2)) {
			if (true
			&&(in->init.c.filled < 5)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 3;
				pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
				tmp->init.c_buffer[pos].m0.var = 4;
				++(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 2;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 3)) {
			if (true
			&&(in->init.c.filled < 5)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 4;
				pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
				tmp->init.c_buffer[pos].m0.var = 3;
				++(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 3;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 4)) {
			if (true
			&&(in->init.c.filled < 5)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 5;
				pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
				tmp->init.c_buffer[pos].m0.var = 2;
				++(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 4;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 5)) {
			if (true
			&&(in->init.c.filled < 5)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 6;
				pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
				tmp->init.c_buffer[pos].m0.var = 1;
				++(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 5;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 6)) {
			if (true
			&&(in->init.c.filled > 0)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 7;
				pos = tmp->init.c.nextRead;
				tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
				tmp->init.c_buffer[pos].m0.pad = 0;
				tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
				--(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 6;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 7)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 8;
				printf("%d", (in->init.c.filled!=5));
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 7;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 8)) {
			if (true
			&&(in->init.c.filled < 5)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 9;
				pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
				tmp->init.c_buffer[pos].m0.var = 9;
				++(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 8;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 9)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 10;
				printf("%d", (in->init.c.filled==5));
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 9;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 10)) {
			if (true
			&&(in->init.c.filled > 0)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 11;
				pos = tmp->init.c.nextRead;
				tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
				tmp->init.c_buffer[pos].m0.pad = 0;
				tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
				--(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 10;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 11)) {
			if (true
			&&(in->init.c.filled > 0)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 12;
				pos = tmp->init.c.nextRead;
				tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
				tmp->init.c_buffer[pos].m0.pad = 0;
				tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
				--(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 11;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 12)) {
			if (true
			&&(in->init.c.filled > 0)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 13;
				pos = tmp->init.c.nextRead;
				tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
				tmp->init.c_buffer[pos].m0.pad = 0;
				tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
				--(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 12;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 13)) {
			if (true
			&&(in->init.c.filled > 0)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 14;
				pos = tmp->init.c.nextRead;
				tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
				tmp->init.c_buffer[pos].m0.pad = 0;
				tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
				--(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 13;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 14)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 15;
				printf("%d", (in->init.c.filled!= 0));
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 14;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 15)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 16;
				printf("%d", in->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 15;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 16)) {
			if (true
			&&(in->init.c.filled > 0)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 17;
				pos = tmp->init.c.nextRead;
				tmp->init.i.var = tmp->init.c_buffer[pos].m0.var;
				tmp->init.c_buffer[pos].m0.pad = 0;
				tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
				--(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 16;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 17)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 18;
				printf("%d", (in->init.i.var == 9 ? 1 : 0));
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 17;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->init.pc.var == 18)) {
			if (true
			&&true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = -1;
				#ifndef NORESETPROCESS
				memset(&tmp->init,-1,sizeof(state_init_t));
				#endif
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 18;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	return states_emitted;
}

extern int spinja_get_transition_groups() {
	return 20;
}
int transition_dependency[][2][10] = {
	// { ... read ...}, { ... write ...}
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,0,0,0,0,0,0,0}}, // 0
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,1,1,0,0,0,0,0}}, // 1
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,1,1,0,0,0,0,0}}, // 2
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,1,1,0,0,0,0,0}}, // 3
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,1,1,0,0,0,0,0}}, // 4
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,1,1,0,0,0,0,0}}, // 5
	{{1,0,1,1,1,0,0,0,0,0},{1,0,1,1,0,0,0,0,0,1}}, // 6
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,0,0,0,0,0,0,0}}, // 7
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,1,1,0,0,0,0,0}}, // 8
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,0,0,0,0,0,0,0}}, // 9
	{{1,0,1,1,1,0,0,0,0,0},{1,0,1,1,0,0,0,0,0,1}}, // 10
	{{1,0,1,1,1,0,0,0,0,0},{1,0,1,1,0,0,0,0,0,1}}, // 11
	{{1,0,1,1,1,0,0,0,0,0},{1,0,1,1,0,0,0,0,0,1}}, // 12
	{{1,0,1,1,1,0,0,0,0,0},{1,0,1,1,0,0,0,0,0,1}}, // 13
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,0,0,0,0,0,0,0}}, // 14
	{{1,0,1,1,0,0,0,0,0,0},{1,0,1,0,0,0,0,0,0,0}}, // 15
	{{1,0,1,1,1,0,0,0,0,0},{1,0,1,1,0,0,0,0,0,1}}, // 16
	{{1,0,1,0,0,0,0,0,0,1},{1,0,1,0,0,0,0,0,0,0}}, // 17
	{{1,0,1,0,0,0,0,0,0,0},{1,0,1,1,0,0,0,0,0,1}}, // 18
	{{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}  // 19
};

extern const int* spinja_get_transition_read_dependencies(int t)
{
	if (t>=0 && t < 20) return 
transition_dependency[t][0];	return NULL;
}

extern const int* spinja_get_transition_write_dependencies(int t)
{
	if (t>=0 && t < 20) return 
transition_dependency[t][1];	return NULL;
}
/*
 * 
 * Guard list:
 *   - 0 - (in->init.pc.var == 0)
 *   - 1 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 2 - (in->init.pc.var == 1)
 *   - 3 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 4 - (in->init.c.filled < 5)
 *   - 5 - (in->init.pc.var == 2)
 *   - 6 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 7 - (in->init.c.filled < 5)
 *   - 8 - (in->init.pc.var == 3)
 *   - 9 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 10 - (in->init.c.filled < 5)
 *   - 11 - (in->init.pc.var == 4)
 *   - 12 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 13 - (in->init.c.filled < 5)
 *   - 14 - (in->init.pc.var == 5)
 *   - 15 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 16 - (in->init.c.filled < 5)
 *   - 17 - (in->init.pc.var == 6)
 *   - 18 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 19 - (in->init.c.filled > 0)
 *   - 20 - (in->init.pc.var == 7)
 *   - 21 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 22 - (in->init.pc.var == 8)
 *   - 23 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 24 - (in->init.c.filled < 5)
 *   - 25 - (in->init.pc.var == 9)
 *   - 26 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 27 - (in->init.pc.var == 10)
 *   - 28 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 29 - (in->init.c.filled > 0)
 *   - 30 - (in->init.pc.var == 11)
 *   - 31 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 32 - (in->init.c.filled > 0)
 *   - 33 - (in->init.pc.var == 12)
 *   - 34 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 35 - (in->init.c.filled > 0)
 *   - 36 - (in->init.pc.var == 13)
 *   - 37 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 38 - (in->init.c.filled > 0)
 *   - 39 - (in->init.pc.var == 14)
 *   - 40 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 41 - (in->init.pc.var == 15)
 *   - 42 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 43 - (in->init.pc.var == 16)
 *   - 44 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 45 - (in->init.c.filled > 0)
 *   - 46 - (in->init.pc.var == 17)
 *   - 47 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 48 - (in->init.pc.var == 18)
 *   - 49 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 50 - true
 */

// Guard-Dependency Matrix:
int gm_dm[][2][10] = {
	// { ... read ...}, { ... write ...}
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 0
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 1
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 2
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 3
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 4
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 5
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 6
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 7
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 8
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 9
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 10
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 11
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 12
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 13
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 14
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 15
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 16
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 17
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 18
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 19
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 20
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 21
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 22
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 23
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 24
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 25
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 26
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 27
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 28
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 29
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 30
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 31
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 32
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 33
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 34
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 35
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 36
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 37
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 38
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 39
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 40
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 41
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 42
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 43
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 44
	{{0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 45
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 46
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 47
	{{0,0,1,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 48
	{{1,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}, // 49
	{{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}}  // 50
};

// Co-Enabled Matrix:
int gm_coen[][51] = {
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{0}
};

// Transition-Guard Matrix:
int* gm_trans[19] = {
((int[]){ 2, 0, 1 }),	// trans     0
((int[]){ 3, 2, 3, 4 }),	// trans     1
((int[]){ 3, 5, 6, 7 }),	// trans     2
((int[]){ 3, 8, 9, 10 }),	// trans     3
((int[]){ 3, 11, 12, 13 }),	// trans     4
((int[]){ 3, 14, 15, 16 }),	// trans     5
((int[]){ 3, 17, 18, 19 }),	// trans     6
((int[]){ 2, 20, 21 }),	// trans     7
((int[]){ 3, 22, 23, 24 }),	// trans     8
((int[]){ 2, 25, 26 }),	// trans     9
((int[]){ 3, 27, 28, 29 }),	// trans    10
((int[]){ 3, 30, 31, 32 }),	// trans    11
((int[]){ 3, 33, 34, 35 }),	// trans    12
((int[]){ 3, 36, 37, 38 }),	// trans    13
((int[]){ 2, 39, 40 }),	// trans    14
((int[]){ 2, 41, 42 }),	// trans    15
((int[]){ 3, 43, 44, 45 }),	// trans    16
((int[]){ 2, 46, 47 }),	// trans    17
((int[]){ 3, 48, 49, 50 })	// trans    18
};

int spinja_get_guard_count() {
	return 51;
}

const int* spinja_get_guards(int t) {
	assert(t < 19 && "spinja_get_guards: invalid transition");
	return gm_trans[t];
}

const int*** spinja_get_all_guards() {
	return (const int***)&gm_trans;
}

const int* spinja_get_guard_may_be_coenabled_matrix(int g) {
	assert(g < 51 && "spinja_get_guards: invalid guard");
	return gm_coen[g];
}

bool spinja_get_guard(void* model, int g, state_t* in) {
	assert(g < 51 && "spinja_get_guards: invalid guard");
	(void)model;
	switch(g) {
		case 0: return (in->init.pc.var == 0);
		case 1: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 2: return (in->init.pc.var == 1);
		case 3: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 4: return (in->init.c.filled < 5);
		case 5: return (in->init.pc.var == 2);
		case 6: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 7: return (in->init.c.filled < 5);
		case 8: return (in->init.pc.var == 3);
		case 9: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 10: return (in->init.c.filled < 5);
		case 11: return (in->init.pc.var == 4);
		case 12: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 13: return (in->init.c.filled < 5);
		case 14: return (in->init.pc.var == 5);
		case 15: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 16: return (in->init.c.filled < 5);
		case 17: return (in->init.pc.var == 6);
		case 18: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 19: return (in->init.c.filled > 0);
		case 20: return (in->init.pc.var == 7);
		case 21: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 22: return (in->init.pc.var == 8);
		case 23: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 24: return (in->init.c.filled < 5);
		case 25: return (in->init.pc.var == 9);
		case 26: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 27: return (in->init.pc.var == 10);
		case 28: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 29: return (in->init.c.filled > 0);
		case 30: return (in->init.pc.var == 11);
		case 31: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 32: return (in->init.c.filled > 0);
		case 33: return (in->init.pc.var == 12);
		case 34: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 35: return (in->init.c.filled > 0);
		case 36: return (in->init.pc.var == 13);
		case 37: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 38: return (in->init.c.filled > 0);
		case 39: return (in->init.pc.var == 14);
		case 40: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 41: return (in->init.pc.var == 15);
		case 42: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 43: return (in->init.pc.var == 16);
		case 44: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 45: return (in->init.c.filled > 0);
		case 46: return (in->init.pc.var == 17);
		case 47: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 48: return (in->init.pc.var == 18);
		case 49: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 50: return true;
	}
	return false;
}

void spinja_get_guard_all(void* model, state_t* in, int* guard) {
	(void)model;
	guard[0] = (in->init.pc.var == 0);
	guard[1] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[2] = (in->init.pc.var == 1);
	guard[3] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[4] = (in->init.c.filled < 5);
	guard[5] = (in->init.pc.var == 2);
	guard[6] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[7] = (in->init.c.filled < 5);
	guard[8] = (in->init.pc.var == 3);
	guard[9] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[10] = (in->init.c.filled < 5);
	guard[11] = (in->init.pc.var == 4);
	guard[12] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[13] = (in->init.c.filled < 5);
	guard[14] = (in->init.pc.var == 5);
	guard[15] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[16] = (in->init.c.filled < 5);
	guard[17] = (in->init.pc.var == 6);
	guard[18] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[19] = (in->init.c.filled > 0);
	guard[20] = (in->init.pc.var == 7);
	guard[21] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[22] = (in->init.pc.var == 8);
	guard[23] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[24] = (in->init.c.filled < 5);
	guard[25] = (in->init.pc.var == 9);
	guard[26] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[27] = (in->init.pc.var == 10);
	guard[28] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[29] = (in->init.c.filled > 0);
	guard[30] = (in->init.pc.var == 11);
	guard[31] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[32] = (in->init.c.filled > 0);
	guard[33] = (in->init.pc.var == 12);
	guard[34] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[35] = (in->init.c.filled > 0);
	guard[36] = (in->init.pc.var == 13);
	guard[37] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[38] = (in->init.c.filled > 0);
	guard[39] = (in->init.pc.var == 14);
	guard[40] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[41] = (in->init.pc.var == 15);
	guard[42] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[43] = (in->init.pc.var == 16);
	guard[44] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[45] = (in->init.c.filled > 0);
	guard[46] = (in->init.pc.var == 17);
	guard[47] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[48] = (in->init.pc.var == 18);
	guard[49] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[50] = true;
}

static const char* var_names[] = {
	"tmp.globals.prioritiseProcess",
	"_nr_pr",
	"tmp.init",
	"c",
	"c",
	"c",
	"c",
	"c",
	"c",
	"i"
};

static const char* var_types[] = {
	"sj_int32",
	"sj_uint8",
	""
};

static const char* const var_type_sj_int32[] = {
	""
};
static const char* const var_type_sj_uint8[] = {
	""
};

static const char* const * const var_type_values[] = {
	var_type_sj_int32,
	var_type_sj_uint8,
	NULL
};

extern const char* spinja_get_state_variable_name(unsigned int var) {
	assert(var < 10 && "spinja_get_state_variable_name: invalid variable");
	return var_names[var];
}

extern int spinja_get_type_count() {
	return 2;
}

extern const char* spinja_get_type_name(int type) {
	assert(type < 2 && "spinja_get_type_name: invalid type");
	return var_types[type];
}

extern int spinja_get_type_value_count(int type) {
	assert(type < 2 && "spinja_get_type_value_count: invalid type");
	return 0;
}

extern const char* spinja_get_type_value_name(int type, int value) {
	return var_type_values[type][value];
}

extern int spinja_get_state_variable_type(int var) {
	assert(var < 10 && "spinja_get_state_variable_type: invalid variable");
	return 0;
}
