/** Generated LTSmin model - run_expression.prom
 * State size:  11 elements (44 bytes)
 * Transitions: 9
 */

#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <assert.h>

typedef struct transition_info
{
	int* label;
	int  group;
} transition_info_t;
typedef union sj_int1 {
	int pad;
	unsigned int var:1;
} sj_int1;
typedef union sj_int8 {
	int pad;
	char var;
} sj_int8;
typedef union sj_int16 {
	int pad;
	short var;
} sj_int16;
typedef union sj_int32 {
	int pad;
	int var;
} sj_int32;
typedef union sj_uint8 {
	int pad;
	unsigned char var;
} sj_uint8;
typedef union sj_uint16 {
	int pad;
	unsigned short var;
} sj_uint16;
typedef union sj_uint32 {
	int pad;
	unsigned int var;
} sj_uint32;
typedef struct sj_channel {
	unsigned int isRendezVous: 2;
	unsigned int nextRead: 15;
	unsigned int filled: 15;
} sj_channel;
typedef 
struct ch_c_t {
	sj_int32 m0;
}
ch_c_t;

typedef 
struct state_globals_t {
	sj_int32 prioritiseProcess;
	sj_uint8 _nr_pr;
}
state_globals_t;

typedef 
struct state_test_proc_t {
	sj_int32 pc;
	sj_int32 num;
}
state_test_proc_t;

typedef 
struct state_init_t {
	sj_int32 pc;
	sj_channel c;
	ch_c_t c_buffer[5];
}
state_init_t;

typedef 
struct state_t {
	state_globals_t globals;
	state_test_proc_t test_proc;
	state_init_t init;
}
state_t;

extern int spinja_get_successor_all( void* model, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg );
extern int spinja_get_successor( void* model, int t, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg );
int spinja_is_atomic(void* model, state_t* tmp) {
	return tmp->globals.prioritiseProcess.var >= 0;
}
int state_size = 11;
extern int spinja_get_state_size() {
	return 11;
}
state_t initial = (state_t){0,0,-1,0,0,0,0,0,0,0,0,0,0};

extern void spinja_get_initial_state( state_t *to )
{
	if(state_size*4 != sizeof(state_t)) { printf("state_t SIZE MISMATCH!: state=%i(%i) globals=%i",sizeof(state_t),state_size*4,sizeof(state_globals_t)); }
	memcpy(to, (char*)&initial, sizeof(state_t));
	to->globals.prioritiseProcess.var = -1;
}
int spinja_get_successor( void* model, int t, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg) {
	transition_info_t transition_info = { NULL, t };
	(void)model; // ignore model
	register int pos;
	state_t local_state;
	state_t* tmp = &local_state;

	static int n_losses = 0;
	static int n_atomics = 0;

	#ifdef COUNTATOMIC
		if(t==1 && spinja_is_atomic(model,in)) printf("handled atomic statements so far: %i\n",++n_atomics);
	#endif
	switch(t) {
	case 0: { // test_proc
		if( true 
		 && (in->test_proc.pc.var == 0)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled < 5) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->test_proc.pc.var = 1;
			pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
			tmp->init.c_buffer[pos].m0.var = in->test_proc.num.var;
			++(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 1: { // test_proc
		if( true 
		 && (in->test_proc.pc.var == 1)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.c.filled > 0) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->test_proc.pc.var = 2;
			pos = tmp->init.c.nextRead;
			tmp->test_proc.num.var = tmp->init.c_buffer[pos].m0.var;
			tmp->init.c_buffer[pos].m0.pad = 0;
			tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
			--(tmp->init.c.filled);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 2: { // test_proc
		if( true 
		 && (in->test_proc.pc.var == 2)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->test_proc.pc.var = 3;
			printf("%d", in->test_proc.num.var);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 3: { // test_proc
		if( true 
		 && (in->test_proc.pc.var == 4)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->test_proc.pc.var = 5;
			printf("%d", in->test_proc.num.var);
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 4: { // test_proc
		if( true 
		 && (in->test_proc.pc.var == 5)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
		 && (in->init.pc.var == -1) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->test_proc.pc.var = -1;
			#ifndef NORESETPROCESS
			memset(&tmp->test_proc,-1,sizeof(state_test_proc_t));
			#endif
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 5: { // init
		if( true 
		 && (in->init.pc.var == 0)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4)) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 1;
			if (-1 != in->test_proc.pc.var) {
				printf ("SpinJa only supports a maximum one dynamic process creation and only for nonactive proctypes.\n");
				printf ("Exiting on 'run test_proc(c, c, 1)'.\n");
				exit (1);
			}
			tmp->test_proc.pc.var = 0;
			++(tmp->globals._nr_pr.var);
			tmp->test_proc.num.var = 1;
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 6: { // init
		if( true 
		 && (in->init.pc.var == 2)
		 && ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4))
		 && true ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = -1;
			#ifndef NORESETPROCESS
			memset(&tmp->init,-1,sizeof(state_init_t));
			#endif
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 7: { // init
		if( true 
		 && (in->init.pc.var == 1)
		 && (in->test_proc.pc.var == 3) ) {
			memcpy(tmp, in, sizeof(state_t));
			tmp->init.pc.var = 2;
			tmp->test_proc.pc.var = 4;
			tmp->test_proc.num.var = 5;
			tmp->globals.prioritiseProcess.var = -1;
			callback(arg,&transition_info,tmp);
			return 1;
		}
		break;
	}
	case 8: { // loss of atomicity
		break;
	}
	}
	return 0;
}

int spinja_get_successor_all( void* model, state_t *in, void (*callback)(void* arg, transition_info_t *transition_info, state_t *out), void *arg) {
	transition_info_t transition_info = { NULL, -1 };
	(void)model; // ignore model
	int states_emitted = 0;
	register int pos;
	state_t local_state;
	state_t* tmp = &local_state;

	static int n_losses = 0;
	static int n_atomics = 0;

	#ifdef COUNTATOMIC
		if(spinja_is_atomic(model,in))printf("handled atomic statements so far: %i\n",++n_atomics);
	#endif
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->test_proc.pc.var == 0)) {
			if (true
			&&(in->init.c.filled < 5)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->test_proc.pc.var = 1;
				pos = (tmp->init.c.nextRead + tmp->init.c.filled) % 5;
				tmp->init.c_buffer[pos].m0.var = in->test_proc.num.var;
				++(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 0;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->test_proc.pc.var == 1)) {
			if (true
			&&(in->init.c.filled > 0)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->test_proc.pc.var = 2;
				pos = tmp->init.c.nextRead;
				tmp->test_proc.num.var = tmp->init.c_buffer[pos].m0.var;
				tmp->init.c_buffer[pos].m0.pad = 0;
				tmp->init.c.nextRead = (tmp->init.c.nextRead+1)%5;
				--(tmp->init.c.filled);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 1;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->test_proc.pc.var == 2)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->test_proc.pc.var = 3;
				printf("%d", in->test_proc.num.var);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 2;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->test_proc.pc.var == 4)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->test_proc.pc.var = 5;
				printf("%d", in->test_proc.num.var);
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 3;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))) {
		if((in->test_proc.pc.var == 5)) {
			if (true
			&&(in->init.pc.var == -1)			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->test_proc.pc.var = -1;
				#ifndef NORESETPROCESS
				memset(&tmp->test_proc,-1,sizeof(state_test_proc_t));
				#endif
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 4;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4))) {
		if((in->init.pc.var == 0)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 1;
				if (-1 != in->test_proc.pc.var) {
					printf ("SpinJa only supports a maximum one dynamic process creation and only for nonactive proctypes.\n");
					printf ("Exiting on 'run test_proc(c, c, 1)'.\n");
					exit (1);
				}
				tmp->test_proc.pc.var = 0;
				++(tmp->globals._nr_pr.var);
				tmp->test_proc.num.var = 1;
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 5;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if(((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4))) {
		if((in->init.pc.var == 2)) {
			if (true
			&&true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = -1;
				#ifndef NORESETPROCESS
				memset(&tmp->init,-1,sizeof(state_init_t));
				#endif
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 6;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	if((in->test_proc.pc.var == 3)) {
		if((in->init.pc.var == 1)) {
			if (true			) {
				memcpy(tmp, in, sizeof(state_t));
				tmp->init.pc.var = 2;
				tmp->test_proc.pc.var = 4;
				tmp->test_proc.num.var = 5;
				tmp->globals.prioritiseProcess.var = -1;
				transition_info.group = 7;
				callback(arg,&transition_info,tmp);
				++states_emitted;
			}
		}
	}
	return states_emitted;
}

extern int spinja_get_transition_groups() {
	return 9;
}
int transition_dependency[][2][11] = {
	// { ... read ...}, { ... write ...}
	{{1,0,1,1,0,1,0,0,0,0,0},{1,0,1,0,0,1,1,1,1,1,1}}, // 0
	{{1,0,1,0,0,1,1,1,1,1,1},{1,0,1,1,0,1,0,0,0,0,0}}, // 1
	{{1,0,1,1,0,0,0,0,0,0,0},{1,0,1,0,0,0,0,0,0,0,0}}, // 2
	{{1,0,1,1,0,0,0,0,0,0,0},{1,0,1,0,0,0,0,0,0,0,0}}, // 3
	{{1,0,1,0,1,0,0,0,0,0,0},{1,0,1,1,0,1,0,0,0,0,0}}, // 4
	{{1,0,0,0,1,0,0,0,0,0,0},{1,1,1,1,1,0,0,0,0,0,0}}, // 5
	{{1,0,0,0,1,0,0,0,0,0,0},{1,0,0,0,1,1,0,0,0,0,0}}, // 6
	{{0,0,1,0,1,0,0,0,0,0,0},{1,0,1,1,1,0,0,0,0,0,0}}, // 7
	{{0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}  // 8
};

extern const int* spinja_get_transition_read_dependencies(int t)
{
	if (t>=0 && t < 9) return 
transition_dependency[t][0];	return NULL;
}

extern const int* spinja_get_transition_write_dependencies(int t)
{
	if (t>=0 && t < 9) return 
transition_dependency[t][1];	return NULL;
}
/*
 * 
 * Guard list:
 *   - 0 - (in->test_proc.pc.var == 0)
 *   - 1 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 2 - (in->init.c.filled < 5)
 *   - 3 - (in->test_proc.pc.var == 1)
 *   - 4 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 5 - (in->init.c.filled > 0)
 *   - 6 - (in->test_proc.pc.var == 2)
 *   - 7 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 8 - (in->test_proc.pc.var == 4)
 *   - 9 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 10 - (in->test_proc.pc.var == 5)
 *   - 11 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2))
 *   - 12 - (in->init.pc.var == -1)
 *   - 13 - (in->init.pc.var == 0)
 *   - 14 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4))
 *   - 15 - (in->init.pc.var == 2)
 *   - 16 - ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4))
 *   - 17 - true
 *   - 18 - (in->init.pc.var == 1)
 *   - 19 - (in->test_proc.pc.var == 3)
 */

// Guard-Dependency Matrix:
int gm_dm[][2][11] = {
	// { ... read ...}, { ... write ...}
	{{0,0,1,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 0
	{{1,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 1
	{{0,0,0,0,0,1,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 2
	{{0,0,1,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 3
	{{1,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 4
	{{0,0,0,0,0,1,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 5
	{{0,0,1,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 6
	{{1,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 7
	{{0,0,1,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 8
	{{1,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 9
	{{0,0,1,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 10
	{{1,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 11
	{{0,0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 12
	{{0,0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 13
	{{1,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 14
	{{0,0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 15
	{{1,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 16
	{{0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 17
	{{0,0,0,0,1,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}, // 18
	{{0,0,1,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0}}  // 19
};

// Co-Enabled Matrix:
int gm_coen[][20] = {
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{0}
};

// Transition-Guard Matrix:
int* gm_trans[8] = {
((int[]){ 3, 0, 1, 2 }),	// trans     0
((int[]){ 3, 3, 4, 5 }),	// trans     1
((int[]){ 2, 6, 7 }),	// trans     2
((int[]){ 2, 8, 9 }),	// trans     3
((int[]){ 3, 10, 11, 12 }),	// trans     4
((int[]){ 2, 13, 14 }),	// trans     5
((int[]){ 3, 15, 16, 17 }),	// trans     6
((int[]){ 2, 18, 19 })	// trans     7
};

int spinja_get_guard_count() {
	return 20;
}

const int* spinja_get_guards(int t) {
	assert(t < 8 && "spinja_get_guards: invalid transition");
	return gm_trans[t];
}

const int*** spinja_get_all_guards() {
	return (const int***)&gm_trans;
}

const int* spinja_get_guard_may_be_coenabled_matrix(int g) {
	assert(g < 20 && "spinja_get_guards: invalid guard");
	return gm_coen[g];
}

bool spinja_get_guard(void* model, int g, state_t* in) {
	assert(g < 20 && "spinja_get_guards: invalid guard");
	(void)model;
	switch(g) {
		case 0: return (in->test_proc.pc.var == 0);
		case 1: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 2: return (in->init.c.filled < 5);
		case 3: return (in->test_proc.pc.var == 1);
		case 4: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 5: return (in->init.c.filled > 0);
		case 6: return (in->test_proc.pc.var == 2);
		case 7: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 8: return (in->test_proc.pc.var == 4);
		case 9: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 10: return (in->test_proc.pc.var == 5);
		case 11: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
		case 12: return (in->init.pc.var == -1);
		case 13: return (in->init.pc.var == 0);
		case 14: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4));
		case 15: return (in->init.pc.var == 2);
		case 16: return ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4));
		case 17: return true;
		case 18: return (in->init.pc.var == 1);
		case 19: return (in->test_proc.pc.var == 3);
	}
	return false;
}

void spinja_get_guard_all(void* model, state_t* in, int* guard) {
	(void)model;
	guard[0] = (in->test_proc.pc.var == 0);
	guard[1] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[2] = (in->init.c.filled < 5);
	guard[3] = (in->test_proc.pc.var == 1);
	guard[4] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[5] = (in->init.c.filled > 0);
	guard[6] = (in->test_proc.pc.var == 2);
	guard[7] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[8] = (in->test_proc.pc.var == 4);
	guard[9] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[10] = (in->test_proc.pc.var == 5);
	guard[11] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 2));
	guard[12] = (in->init.pc.var == -1);
	guard[13] = (in->init.pc.var == 0);
	guard[14] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4));
	guard[15] = (in->init.pc.var == 2);
	guard[16] = ((in->globals.prioritiseProcess.var < 0) || (in->globals.prioritiseProcess.var == 4));
	guard[17] = true;
	guard[18] = (in->init.pc.var == 1);
	guard[19] = (in->test_proc.pc.var == 3);
}

static const char* var_names[] = {
	"tmp.globals.prioritiseProcess",
	"_nr_pr",
	"tmp.test_proc",
	"num",
	"tmp.init",
	"c",
	"c",
	"c",
	"c",
	"c",
	"c"
};

static const char* var_types[] = {
	"sj_int32",
	"sj_uint8",
	""
};

static const char* const var_type_sj_int32[] = {
	""
};
static const char* const var_type_sj_uint8[] = {
	""
};

static const char* const * const var_type_values[] = {
	var_type_sj_int32,
	var_type_sj_uint8,
	NULL
};

extern const char* spinja_get_state_variable_name(unsigned int var) {
	assert(var < 11 && "spinja_get_state_variable_name: invalid variable");
	return var_names[var];
}

extern int spinja_get_type_count() {
	return 2;
}

extern const char* spinja_get_type_name(int type) {
	assert(type < 2 && "spinja_get_type_name: invalid type");
	return var_types[type];
}

extern int spinja_get_type_value_count(int type) {
	assert(type < 2 && "spinja_get_type_value_count: invalid type");
	return 0;
}

extern const char* spinja_get_type_value_name(int type, int value) {
	return var_type_values[type][value];
}

extern int spinja_get_state_variable_type(int var) {
	assert(var < 11 && "spinja_get_state_variable_type: invalid variable");
	return 0;
}
